require 'dosish'

$KCODE = 'SJIS'

fnames = <<EOT.split(/\n/)
\
\\\
\\\
c:\\konna namae tukenjaneeyo\\pun pun\\\vZ.txt
usr
usr\\
usr\\src
usr\\src\\
\\
\\usr
\\usr\\
\\usr\\src
C:
C:\\
C:\\usr
C:\\usr\\
C:\\usr\\src
C:\\usr\\src\\
\\\\server
\\\\server\\
\\\\server\\share
\\\\server\\share\\
\\\\server\\share\\usr
\\\\server\\share\\usr\\
EOT
fnames.each{|s| print [:drive , s, DOSish.drivename(s)].join("\t"), "\n"}
fnames.each{|s| print [:root  , s, DOSish.rootdir(s)].join("\t"), "\n"}
fnames.each{|s| print [:dir   , s, DOSish.dirname(s)].join("\t"), "\n"}
fnames.each{|s| print [:base  , s, DOSish.basename(s)].join("\t"), "\n"}

def assert(id, cond1, cond2)
  unless cond1 == cond2
    puts "fail##{id} #{cond1.inspect} != #{cond2.inspect}"
  end
end

  def fname_join(*args)
    args.flatten.collect do |i|
      s = i.gsub(/\\/, '/')
      case s
      when %r'^/$', %r'^\w:/$', %r'^//\w+/\w+/$'
        s.chop!
      end
      s
    end.join(DOSish::SEPARATOR)
  end

fnames.each{|s|
  assert :drive0, DOSish.drivename(s), DOSish.drivename(s.gsub(/\\/, '/'))
  assert :drive1, DOSish.drivename(s), DOSish.drivename(s.gsub(/\//, '\\'))
  assert :root0, DOSish.rootdir(s), DOSish.rootdir(s.gsub(/\\/, '/'))
  assert :root1, DOSish.rootdir(s), DOSish.rootdir(s.gsub(/\//, '\\'))
  assert :dir0, DOSish.dirname(s), DOSish.dirname(s.gsub(/\\/, '/'))
  assert :dir1, DOSish.dirname(s), DOSish.dirname(s.gsub(/\//, '\\'))
  assert :base0, DOSish.basename(s), DOSish.basename(s.gsub(/\\/, '/'))
  assert :base1, DOSish.basename(s), DOSish.basename(s.gsub(/\//, '\\'))

  assert :drive2, DOSish.drivename("C:\\"), "C:"
  assert :drive3, DOSish.drivename("\\\\server\\share"), "//server/share"
  assert :dir2, DOSish.dirname("C:\\"), "C:/"
  assert :dir3, DOSish.dirname("\\\\server\\share\\"), "//server/share/"
  assert :dir4, DOSish.dirname("C:/"), "C:/"
  assert :dir5, DOSish.dirname("//server/share/"), "//server/share/"

  pair = DOSish.split(s)
  assert :join0, s.gsub(/\\/, '/'), DOSish.join(pair)
  assert :join1, fname_join(pair), DOSish.join(pair)
  assert :pair1, pair, [ DOSish.dirname(s), DOSish.basename(s) ]
}
